Subject: Re: NNCP road warrior

From: Jonathan Lane <[email-masked]>
Date: Sat, 8 Jan 2022 00:57:44 +0000

On Thu, Jan 06, 2022 at 02:54:39PM -0600, John Goerzen wrote:
> So I have been reflecting on the recent conversations about two
> different routes and such, and thought "can we solve this problem at a
> different layer?"
> 
> I've been looking into two options that would be very interesting here.
> 
> One is Yggdrasil network, https://yggdrasil-network.github.io/ .  This
> is an overlay network atop the public Internet, that is fully end-to-end
> encrypted all the time.  More particularly, the entire global network is
> an auto-healing mesh, so if you take your laptop from home to work, it
> will find a new path online (or re-establish a link with the same peer)
> and your IP address remains the same.  IP addresses are v6 only and are
> derived from the node's public key, so each person gets basically a
> globally-routable static IP, plus also a /64 subnet if you like.  You
> can also run Yggdrasil in an entirely closed network by simply never
> connecting any of the nodes to a public peer on the main network (though
> the moment one node is connected to the main network, they all are
> reachable there via mesh routing)
> 
> Tinc vpn https://tinc-vpn.org/ is another option.  While it came along
> long before Yggdrasil, I think of it as sort of a private-only
> alternative.  Like Yggdrasil, it has mesh routing so you can reach any
> of your nodes via any others so long as there is a path somewhere,
> somehow.  Unlike Yggdrasil, it's aimed more at traditional VPN uses and
> lets you specify your own IP ranges, routing between networks, etc.
> 
> A sort of third option is Tor.  I've tried this for awhile, and operate
> a couple of nncp-daemons as a Tor onion service.  This achieves the
> portability I'm looking for, but is slow.  EXTREMELY slow.  So slow, in
> fact, that NNCP seems to have a 10-second timeout on connect that often
> gets triggered.

I think this gets back into the NNCP+Syncthing hybrid.  In my recent
experience, the only places I don't have 5G/LTE on par with my home
LAN's uplink are -really- far off the beaten path, like a ship off shore
or on airplane wifi, and those situations tend to align more with just
working offline anyways.  Multi-routing only makes sense for metered
connections where you want SOME connectivity, which I no longer have.

For those cases where you need an overlay to contact your home or a
well-located server, I enjoy Wireguard.  It's got native support in
GNU/Linux and OpenBSD, and a nice set of mobile apps.  Wireguard is also
much faster than Tor or even OpenVPN.  Yggdrasil is something I haven't
tried, but based on my experience with CJDNS it probably works fine.